#ponizej znajduje sie przykladowa analiza EOF wraz z regresją wielokrotną
#PC SLP do temeraptury powietrza

#1
#zaladowanie danych z Reanalizy NCEP NCAR

sst = sst.NCEP(lon = c(-40,10), lat = c(35,75))

#przykladowe wykreslenie dla Stycznia

map(sst, it='Jan')

#2
#obliczenie EOF dla stycznie

eof_sst_1 = EOF(sst, it='Jan', verbose = TRUE)

#wykresy
plot(eof_sst_1, new = FALSE, pattern = 1)

#wykreslenie mapy dla wybranego EOF

map(eof_sst_1, pattern = 1, new = FALSE)

# 3 
#przygotowanie danych (serii czasowych)
#zlozenie danych PC z okreslonej liczby EOFow

#ponizej nalezy wpisac liczbe EOF ktora nas interesuje

n = 7

PCs = eof_sst_1[ ,1:n]
PCs = as.data.frame(PCs)
PCs = cbind(ROK = c(1982:2013), PCs)

# 4
#wczytanie danych odnosnie temperatury powietrza w Europie Srodkowej
temp = read.table("pc_reg_temp.txt", header = TRUE)

#wybieramy tylko styczen
temp_1 = temp[which(temp$MC == 1), ]

#5
#teraz trzeba przyciac dane do wspolnego okresu i polacyc w jedna data.frame
#wspolny okres to 1951-2012 tak wiec najpier wybierzemy te dane z PCs


PCs_8212 = PCs[which(PCs$ROK >= 1982 & PCs$ROK <= 2012), ]

#6
#teraz temperatura

temp_1_8212 = temp_1[which(temp_1$ROK >= 1982 & temp_1$ROK <= 2012), ]

#7
#gotowe, a teraz polaczymy nasze dane w jedna dataframe

data = cbind(PCs_8212[ , ], temp_1_8212[ , 3])

#zmienmy sobie r?wniez nazwy kolumn
colnames(data) = c("ROK", "PC1", "PC2", "PC3", "PC4", "PC5", "PC6", "PC7", "TEMP")

#teraz podlaczzmy dane w celu latwiejszego z nich korzystania


attach(data)

#8
#model z PC1

model1 = lm(TEMP~PC1)

summary(model1)


plot(TEMP, model1$fitted.values, ylab = "TEMP (model)")
abline(0,1, col = 2, lwd = 2)

qqplot(TEMP, model1$fitted.values)
abline(0,1, col = 2, lwd = 2)

plot(1982:2012, TEMP, type = "l", xlab = "ROK")
lines(1982:2012, model1$fitted.values, col = 2, lwd = 2)

#8
#teraz model ze wszystkimmi wybranymi PCs


model2 = lm(TEMP~PC1+PC2+PC3+PC4+PC5+PC6)
summary(model2)




#teraz wybieramy tylko te które wg nas mają znaczenie

model3 = lm(TEMP~PC3+PC4)
summary(model3)





plot(1982:2012, TEMP, type = "l", xlab = "ROK")
lines(1982:2012, model1$fitted.values, col = 4, lwd = 2)
lines(1982:2012, model2$fitted.values, col = 2, lwd = 2)
lines(1982:2012, model3$fitted.values, col = 3, lwd = 2)



qqplot(TEMP, model3$fitted.values)
abline(0,1, col = 2, lwd = 2)

AIC(model1, model2, model3)

#9
# pokazanie wyników modeli na diagramie Taylora
#niezbędna jest paczka plotrix

taylor.diagram(TEMP, model1$fitted.values, add = FALSE, col = 2, sd.arcs = TRUE, ref.sd = TRUE)
taylor.diagram(TEMP, model2$fitted.values, add = TRUE, col = 3, sd.arcs = TRUE, ref.sd = TRUE)
taylor.diagram(TEMP, model3$fitted.values, add = TRUE, col = 4, sd.arcs = TRUE, ref.sd = TRUE)


detach(data)


